#include <iostream>
#include <winsock.h>
#include <cstring>
#include <fstream>
#include <vector>
using namespace std;



void klaida_gaunant()   
{
cout << "Nepavyko gauti duomenu." << endl;
system("pause");
exit(1);
}

void klaida_siunciant()
{
cout << "Nepavyko nusiusti duomenu." << endl;
system("pause");
exit(1);
}

void perziureti(SOCKET soketas)
{
int nr=0, ilgis;
char uzrasas[256];
ilgis = recv(soketas, uzrasas, 256, 0);
if ((ilgis != 256) && (ilgis != 1))  
   klaida_gaunant();                  
while (uzrasas[0]!=3)
      {
      cout << ++nr << ") " << uzrasas << endl;
      ilgis = recv(soketas, uzrasas, 256, 0);
      if ((ilgis != 256) && (ilgis != 1))
         klaida_gaunant();
      }    
}


void itraukti_uzrasa(SOCKET soketas)
{
cout << "Iveskite nauja uzrasa" << endl;
char uzrasas[256];
cin.getline (uzrasas,1);
cin.getline (uzrasas,256);
if (send(soketas, uzrasas, 256, 0) != 256)
   klaida_siunciant();
cout << "Itrauktas naujas irasas." << endl;
}


void istrinti_uzrasa(SOCKET soketas)
{
cout << "Iveskite uzraso numeri." << endl;
char nr[6], uzrasas[256];
cin >> nr;
if (nr[0] < '1')
   {
   cout << "Ivedete netinkama skaiciu, bandykite dar karta" << endl;
   cin >> nr;
   }
if (send(soketas, nr, 6, 0) != 6)
   klaida_siunciant();
int ilgis;
ilgis = recv(soketas, uzrasas, 256, 0);
if ((ilgis != 256) && (ilgis != 1))
   klaida_gaunant();
   if (uzrasas[0]==3)
      cout << "Blogai nurodete numeri!" << endl;
   else cout << "Uzrasas '" << uzrasas << "' sekmingai istrintas." << endl;
}


void meniu(SOCKET soketas)
{
char pasirinkimas='0';
while (pasirinkimas!='4')
      {
      cout << endl;
      cout << "1. Perziureti uzrasus" << endl;
      cout << "2. Itraukti nauja uzrasa" << endl;
      cout << "3. Istrinti uzrasa" << endl;
      cout << "4. Baigti darba" << endl;
      cin >> pasirinkimas;
      while (pasirinkimas > '4' || pasirinkimas < '1')
      {
      cout << "Klaida! Iveskite skaiciu tarp 1 ir 4!" << endl;
      cin >> pasirinkimas;
      }
      cout << endl;
      if (send(soketas, &pasirinkimas, 1, 0) != 1)
         klaida_siunciant();
      switch(pasirinkimas)
             {
             case '1' : perziureti(soketas); 
                        break;
             case '2' : itraukti_uzrasa(soketas);
                        break;
             case '3' : istrinti_uzrasa(soketas);
                        break;
             default : break;
             }     
      }
cout << "Jus baigete darba." << endl;
}


void nauja_knygute(SOCKET soketas)
{
char pranesimas[256], numeris[6];
cout << "Iveskite savo uzrasu knygutei slaptazodi." << endl;
cin >> pranesimas;
if (send(soketas, pranesimas, 256, 0) != 256)
   klaida_siunciant();
if (recv(soketas, numeris, 6, 0) != 6)
   klaida_gaunant();
cout << "Jusu knygutes numeris - " << numeris << ". Isminkite ji!!" << endl; 
meniu(soketas);
}


void turi_knygute(SOCKET soketas)
{
char numeris[6], pranesimas[256];
cout << "Iveskite savo uzrasu knygutes numeri" << endl;
cin >> numeris;
if (send(soketas, numeris, 6, 0) != 6)
   klaida_siunciant();
if (recv(soketas,pranesimas, 1, 0) != 1)
   klaida_gaunant();
if (pranesimas[0] == 'n')
   {
   cout << "Blogai nurodete uzrasu knygutes numeri." << endl << endl;
   return;
   }
cout << "Iveskite slaptazodi" << endl;
cin >> pranesimas;
if (send(soketas, pranesimas, 256, 0) != 256)
   klaida_siunciant();
if (recv(soketas, pranesimas, 1, 0)!=1)
   klaida_gaunant();
if (pranesimas[0] == 'n')
   {
   cout << "Ivedete netinkama slaptazodzio ir numerio kombinacija." << endl << endl;
   return;
   }
   else meniu(soketas);
}


void knyguciu_meniu(SOCKET soketas)
{
char pasirinkimas;
cout << "Jeigu turite uzrasu knygute, spauskite 1." << endl;
cout << "Jeigu norite sukurti nauja uzrasu knygute, spauskite 2." << endl;
cin >> pasirinkimas;
while ((pasirinkimas != '1') && (pasirinkimas != '2'))
      {
      cout << "Klaida! Iveskite 1 arba 2!" << endl;
      cin >> pasirinkimas;
      }
if (send(soketas, &pasirinkimas, 1, 0) != 1)
   klaida_siunciant();
if (pasirinkimas == '2')
   nauja_knygute(soketas);
   else turi_knygute(soketas);
}
      

int main(int argc, char * argv[])
{
WSADATA wsaData;
if (WSAStartup(MAKEWORD(2,0), &wsaData) != 0)  //inicializuojam winsock
   {
   cout << "Nepavyko paleisti WSAStartup()" ;
   system("pause");
   exit(1);
   }



	short portas;
	if(strlen(argv[0]) > 0)
	{
		int sk = atoi(argv[0]);
		if((sk == 0) && (strcmp("0", argv[0]) != 0))
			;
		else
			portas = sk; //port
	}

string ip ;     //ivedam ip
//cout << "Iveskite serverio ip" << endl;
cin >> ip;
	{
		int ip = atoi(argv[1]);
		if((ip == 0) && (strcmp("0", argv[0]) != 0))
			;
	
		
	}


hostent *hostas;   //pagaminam is stringo ip hosto adresa
if ((hostas = gethostbyname(&ip[0])) == NULL) //apibreziam serveri pagal jo varda
   {
   cout << "Nepavyko gauti serverio adreso." << endl;
   system("pause");
   exit(1);
   }

char pasirinkimas='1';
while (pasirinkimas=='1')   //kad galima butu kelis kartus kreiptis i serveri
      {
      SOCKET soketas = socket(AF_INET, SOCK_STREAM, 0); //1-per tcp/ip 2-stream orentied socket
      if (soketas == INVALID_SOCKET) 
         {
         cout << "Klaida sukuriant soketa." << endl;
         system("pause");
         exit(1);
         }
      struct sockaddr_in serveris;  
      serveris.sin_family = AF_INET;           
      serveris.sin_port = htons(portas);      
      serveris.sin_addr = *((struct in_addr *)hostas->h_addr);
      memset(&(serveris.sin_zero), '\0', 8);

      if (connect(soketas,(struct sockaddr *)&serveris,sizeof(struct sockaddr)) == -1)   //jungiames prie servo
         {
         cout << "Nepavyko prisijungti." << endl;
         system("pause");
         exit(1);
         }
      cout << "Pavyko prisijungti prie serverio." << endl;
      knyguciu_meniu(soketas);  
      cout << "Jeigu norite testi darba, iveskite 1." << endl; 
      cout << "Jeigu norite baigti darba, iveskite bet koki kita simboli." << endl;
      cin >> pasirinkimas; 
      closesocket(soketas);  
      }      
WSACleanup();   //pravalom WSA
cout << "Rysys su serveriu nutrauktas." << endl;
system("pause");
}
